<?php
class ControllerPaymentmabna extends Controller {
	protected function index() {
	
	
		$this->language->load('payment/mabna');
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
	
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$this->load->library('encryption');
			
		$encryption = new Encryption($this->config->get('config_encryption'));
		$this->data['amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

		
		$this->data['order_id'] = $this->session->data['order_id'];
		$this->data['back'] = $this->url->https('checkout/payment', '', 'SSL');
		$amount = $this->data['amount'];
		
		if($this->currency->getCode()!='RLS') {
		    $this->data['amount'] = $amount * 10;
	    }
		
        $this->data['order_id'] = $this->session->data['order_id'];
		$this->data['redirect_url']  =  ($this->url->https('payment/mabna/callback','', 'SSL'));
		$this->data['action'] = "https://mabna.shaparak.ir";
		$this->id       = 'payment';
		
		$amount = trim($this->data['amount']);
		$merchant = $this->config->get('mabna_PIN');
		$terminal = $this->config->get('sha1Key');
		$invoiceNumber = time();
		$redirectAddress= $this->data['redirect_url'];
		
		$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;
		$pat = dirname(__FILE__);
		$fp = fopen($pat . '/../../../public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";


		// Amount
		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource);

		$Amount = base64_encode($crypttext);
		// CRN

		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource);
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource);
		$TID = base64_encode($crypttext);

		// redirectAddress
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
		$referal = base64_encode($crypttext);

		$key = file_get_contents($pat . '/../../../private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
			"CRN" => $CRN,
			"MID" => $MID,
			"REFERALADRESS" => $referal,
			"SIGNATURE" => base64_encode($signature),
			"TID" => $TID,
		));

		include($pat . '/nusoap.php');
		$__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
		$client = new nusoap_client($__SOAP, 'wsdl');
		$WSResult = $client->call("reservation", $inputArray);
		$signature = base64_decode($WSResult['return']['signature']);
		$ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);
		openssl_free_key($key_resource);
		if ($ok == 1 && $WSResult['return']['result'] == 0)
		{
			$this->data['token'] = $WSResult['return']['token'];
			$_SESSION['order_id'] = $this->data['order_id'];
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/mabna.tpl')) 
			{
				$this->template = $this->config->get('config_template') . '/template/payment/mabna.tpl';
			} else 
			{
				$this->template = 'default/template/payment/mabna.tpl';
			}

			$this->render();
		}else
		{
			echo  $WSResult['return']['token'];
		}
	}

	public function callback() 
	{
		$this->language->load('payment/mabna');
		@session_start();
		$order_id = $_SESSION['order_id'];
		$resultCode = $this->request->post['resultCode'];

	
		
		$this->data['text_wait'] = $this->language->get('text_wait');
		$this->data['text_heading'] = $this->language->get('text_heading');
		$this->data['text_results'] = $this->language->get('text_results');
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_continue'] = $this->language->get('button_continue');
		$this->data['breadcrumbs'] = array();
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->https('common/home', '', 'SSL'), 'separator' => false);
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_heading'), 'href' => $this->url->https('payment/mabna/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$this->data['error_warning'] = '';
		
		if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
{
			$merchant = $this->config->get('mabna_PIN');

			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);
			
			$amount = @$this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);	
			
			if($this->currency->getCode()!='RLS') 
			{
				$amount = $amount * 10;
			}
			

			
			if ($order_info) 
			{
					$pat = dirname(__FILE__);
					if(!function_exists('timestamp_to_iso8601'))
					{
						include_once($pat . '/nusoap.php');
					}
					$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
					$error = $client->getError();
					
					$fp = fopen($pat . '/../../../public.txt', "r");
					$pub_key = fread($fp, 8192);
					fclose($fp);
					if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
						$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

					if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
						$pub_key .= "\n-----END PUBLIC KEY-----";

					$key_resource = openssl_get_publickey($pub_key);

					openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
					$TRN = base64_encode($crypttext);

					// CRN
					openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
					$CRN = base64_encode($crypttext);

					// MID
					openssl_public_encrypt($merchant, $crypttext, $key_resource );
					$MID = base64_encode($crypttext);

					// Sign data
					$source = $merchant.$_POST["TRN"].$_POST["CRN"];
					
					$key = file_get_contents($pat . '/../../../private.txt');

					if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
						$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

					if (strpos($key, '-----END PRIVATE KEY-----') === false)
						$key .= "\n-----END PRIVATE KEY-----";

					$priv_key = openssl_pkey_get_private($key);
					$signature = '';
					openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
					$inputArray = array("SaleConf_req" => array("MID"    => $MID,
																"CRN"    => $CRN,
																"TRN"    => $TRN,
																"SIGNATURE" => base64_encode($signature)));
					$WSResult = $client->call("sendConfirmation", $inputArray);
					$error = $client->getError();
					$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
					$data      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];
					$ok = openssl_verify($data, $signature, $key_resource);
					if ($ok == 1) 
					{
						 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
						 {
							if( floatval($WSResult["return"]["AMOUNT"]) == floatval($amount) )
							{
								$referenceId  = $WSResult["return"]["TRN"];
								$this->data['authority'] = $referenceId;
								$this->data['continue'] = $this->url->https('checkout/success');
								$this->model_checkout_order->confirm($order_id, $this->config->get('mabna_order_status_id'),' referenceId:'.$referenceId);
								$this->response->setOutput('<html><head><meta http-equiv="refresh" CONTENT="2; url=index.php?route=checkout/success"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1576;&#1575; &#1578;&#1588;&#1705;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1578;&#1705;&#1605;&#1740;&#1604; &#1588;&#1583;. &#1604;&#1591;&#1601;&#1575; &#1670;&#1606;&#1583; &#1604;&#1581;&#1592;&#1607; &#1589;&#1576;&#1585; &#1705;&#1606;&#1740;&#1583; &#1608; &#1740;&#1575; <a href="index.php?route=checkout/success"><b>&#1575;&#1740;&#1606;&#1580;&#1575; &#1705;&#1604;&#1740;&#1705; &#1606;&#1605;&#1575;&#1740;&#1740;&#1583;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
				
							}
							else
							{
								$this->data['error_warning'] = 'مبلغ واریز و مبلغ سفارش برابر نیست';
								$this->data['continue'] = $this->url->https('checkout/checkout');
								$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
							}
						 }
						 else
						{
							$this->data['error_warning'] = 'سفارش قبلا پرداخت شده است';
							$this->data['continue'] = $this->url->https('checkout/checkout');
							$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
						}
					}
					else
					{
						$this->data['error_warning'] = 'خطا در وریفای اطلاعات';
						$this->data['continue'] = $this->url->https('checkout/checkout');
						$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
					}
				
				
			}
			else 
			{
				$this->data['error_warning'] ='سفارش یافت نشد';
				$this->data['continue'] = $this->url->https('checkout/checkout');
				$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			}
		} 
		else 
		{
			$this->data['error_warning'] = '';
			$this->data['continue'] = $this->url->https('checkout/checkout');
			$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
		}
		
		

	}

}
?>